unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, SQLDB, DB, SQLite3Conn, Forms, Controls, Graphics, Dialogs,
  DBCtrls, DBGrids, ExtCtrls, StdCtrls, Grids;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ButtonAddList: TButton;
    DataSource: TDataSource;
    DBGrid: TDBGrid;
    Connection: TSQLite3Connection;
    DBNavigator1: TDBNavigator;
    Query: TSQLQuery;
    Splitter1: TSplitter;
    StringGrid1: TStringGrid;
    Transaction: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
    procedure ButtonAddListClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  LFileName: String;
begin
  LFileName := GetCurrentDir + PathDelim + 'test.sql';

  Connection.DatabaseName := LFileName;
  Connection.HostName := 'localhost';
  Connection.Connected := True;

  Query.SQL.Text:=
    'CREATE TABLE IF NOT EXISTS test (' +
    'id INTEGER PRIMARY KEY AUTOINCREMENT, ' +
    'foo VARCHAR);';
  Query.ExecSQL;
  Transaction.Commit;

  Query.SQL.Text := 'SELECT id, foo FROM test;';
  Query.PacketRecords := 100;
  Query.Open;

  StringGrid1.LoadFromCSVFile(GetCurrentDir + PathDelim + 'Liste.csv');
end;

procedure TForm1.ButtonAddListClick(Sender: TObject);
var
  SL: TStringList;
  i: Integer;
begin
  SL := TStringList.Create;
  try
    SL.LoadFromFile(GetCurrentDir + PathDelim + 'Liste.csv');
    SL.Delimiter := ';';
    SL.DelimitedText := SL.Text;
    for i := 0 to SL.Count - 1 do
    begin
      if SL[i].IsEmpty then Continue;
      Query.Append;
      Query.Fields[1].AsString := SL[i];
      Query.Post;
    end;
    Query.ApplyUpdates;
  finally
    SL.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to StringGrid1.RowCount - 1 do
  begin
    Query.Append;
    Query.Fields[1].AsString := StringGrid1.Cells[0, i];
    Query.Post;
  end;
  Query.ApplyUpdates;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Query.ApplyUpdates;
  Transaction.Commit;
end;

end.

